%sections = ();
read_sections_conf( 'sections.conf', \%sections );
print_sections_conf();

{
    my $alias = "patch";
    my $sign_ID = "0x729F899D";
    foreach my $valid_section (keys %sections) {
	foreach $valid_alias (@{$sections{$valid_section}->{aliases}} ) {
	    if ($alias eq $valid_alias) {
		foreach my $valid_ID (@{$sections{$valid_section}->{add_IDs}},
				      @{$sections{$valid_section}->{adm_IDs}}) {
		    if ( $valid_ID eq $sign_ID ) {
			print "access granted\n";
			# return 0; # access granted
		    }
		}
	    }
	}
    }
}

sub print_sections_conf {
    print "printing all section information:\n";
    foreach my $section (keys %sections) {
	print "section: _${section}_\n";
	foreach my $info ('aliases', 'adm_IDs', 'add_IDs') {
	    print "\t$info:\n";
	    foreach $foo (@{$sections{$section}->{$info}} ) {
		print "\t\t_${foo}_\n";
	    }
	}
	print "\tAllowSimpleMails: ". $sections{$section}->{AllowSimpleMail}."\n";
	if ($sections{$section}->{AllowSimpleMail} =~ /^(AD[MD])$/) {
	    print "\tSimpleMail allowed: $1\n";
	}	    
    }
}

sub read_sections_conf {
    my ($filename, $sections_rh) = @_;

    open(SOURCE, "< $filename") or 
	mdie(1, "ERROR: Can't open file \"$filename\" for reading.\n");
    my @sections_conf = <SOURCE>;
    close(SOURCE);

    my $section = undef;
    foreach $line (@sections_conf) {
	if ( $line =~ /^name:\s*([^\n]*?)\s*$/i ) {
	    $section = $1;
	    $sections_rh->{$section}->{AllowSimpleMail} = 'NO';
	} elsif ( defined $section ) {
	    if ( $line =~  /^aliases:\s*([^\n]*)$/i ) {
		@aliases = split( /(?:\s*,\s*|\s+)/ ,  $1 );
                 # quite hackish: /(?:\s+|\s*,\s*)/ would not run!
		foreach my $alias (@aliases) {
		    push(@{$sections_rh->{$section}->{aliases}}, uc($alias) );
		}
	    } elsif ( $line =~ /^[^\#]*(ADM|ADD)\s+SimpleMail/i ) {
		$sections_rh->{$section}->{AllowSimpleMail} = uc($1);
	    } elsif ( $line =~ /^[^\#]*ADM\s+(0x[0-9A-Fa-f]{8})/i ) {
		push(@{$sections_rh->{$section}->{adm_IDs}}, uc($1) );
	    } elsif ( $line =~ /^[^\#]*ADD\s+(0x[0-9A-Fa-f]{8})/i ) {
		push(@{$sections_rh->{$section}->{add_IDs}}, uc($1) );
	    } # else { ignore lines that are not understood }
	}
    }
    return 0;
}

sub read_sections_conf_3 {
    my $filename = $_[0];

    open(SOURCE, "< $filename") or 
	mdie(1, "ERROR: Can't open file \"$filename\" for reading.\n");
    my @sections_conf = <SOURCE>;
    close(SOURCE);

    my $section = undef;
    foreach $line (@sections_conf) {
	if ( $line =~ /^name:\s*([^\n]*?)\s*$/i ) {
	    $section = $1;
	} elsif ( defined $section ) {
	    if ( $line =~  /^aliases:\s*([^\n]*)$/i ) {
		@aliases = split( /(?:\s*,\s*|\s+)/ ,  $1 );
                 # quite hackish: /(?:\s+|\s*,\s*)/ would not run!
		foreach my $alias (@aliases) {
		    push(@{$sections{$section}->{aliases}}, $alias);
		}
	    } elsif ( $line =~ /^[^\#]*ADD\s+(0x[0-9A-Fa-f]{8})/i ) {
		push(@{$sections{$section}->{add_IDs}}, $1);
	    } elsif ( $line =~ /^[^\#]*ADM\s+(0x[0-9A-Fa-f]{8})/i ) {
		push(@{$sections{$section}->{adm_IDs}}, $1);
	    } # else { ignore lines that are not understood }
	}
    }
    return 0;
}

sub read_sections_conf_2 {
    my $filename = $_[0];
    {
	local $/ = "[MWIKI-SECTION]\n";
	open(SOURCE, "< $filename") or 
	    mdie(1, "ERROR: Can't open file \"$filename\" for reading.\n");

	my $header_part = <SOURCE>; # strip of header (incl. comments)
	
	my $section = undef;
	foreach $record (<SOURCE>) {
	    chomp($record);
	    my @lines = split("\n", $record );
	    undef $section;
	    foreach $line (@lines) {
		if ( $line =~ /^name:\s*([^\n]*?)\s*$/i ) {
		    $section = $1;
		} elsif ( defined $section ) {
		    if ( $line =~  /^aliases:\s*([^\n]*)$/i ) {
			@aliases = split( /(?:\s*,\s*|\s+)/ ,  $1 ); # hackish...
			foreach my $alias (@aliases) {
			    push(@{$sections{$section}->{aliases}}, $alias);
			}
		    } elsif ( $line =~ /^[^\#]*ADD\s+(0x[0-9A-Fa-f]{8})/i ) {
			push(@{$sections{$section}->{add_IDs}}, $1);
		    } elsif ( $line =~ /^[^\#]*ADM\s+(0x[0-9A-Fa-f]{8})/i ) {
			push(@{$sections{$section}->{adm_IDs}}, $1);
		    } # else { ignore lines that are not understood }
		}
	    }
	}
	close(SOURCE);
    }
    return 0;
}
